#include<iostream>
#include<fstream>
#include<string>
#include<windows.h>
#include<memory.h>
#include"console.h"
#include"color.h"
using namespace std;
//ofstream fdebug("debug.txt");
class Game {
private:
	COORD lPos= {0,0};//ڵǰ
	COORD state;//
	int winside[3][3],//ռ־
		stateNum[3][3],//ÿµ
		block_color[3][3][3][3],//ɫ
		limit,//ƣΪ0κλӣֻڵǰ 
		side;//ӵһ 
	string sym[3]= {"","",""};//־
	int board[3][3][3][3];//
	//ϽתΪ̨
	COORD nToPos(COORD state_pos) {
		short int x=state_pos.Y*16,y=state_pos.X*8;
		return COORD {x,y};
	}
	//ڸתΪ̨
	COORD lToCPos() {
		COORD pos=nToPos(state);
		pos.X+=lPos.Y*4+2,pos.Y+=lPos.X*2+1;
		return pos;
	}
	COORD lToCPos(COORD local_pos) {
		COORD pos=nToPos(state);
		pos.X+=local_pos.Y*4+2,pos.Y+=local_pos.X*2+1;
		return pos;
	}
	//mode:ģʽ0ΪƵ飬1Ϊֻڵǰƶ
	int getInput(int mode,Color c) {
		int input=0;
		COORD oldPos,oldState;
		while(1) {
			oldPos=lPos,oldState=state;
			setPos(lToCPos());
			cout<<c+WHITE<<sym[board[state.X][state.Y][lPos.X][lPos.Y]]<<WHITE;
			input=getch();
			if(input==13&&board[state.X][state.Y][lPos.X][lPos.Y]==0)return 0;
			else if(input=='s')return 1;
			else if(input=='q')return 2;
			else if(input==224) {
				input=getch();
				if(input==72) {
					if(lPos.X>0)--lPos.X;
					else if(mode==0) {
						if(winside[1][state.Y]==0&&state.X>1)lPos.X=2,state.X=1;
						else if(winside[0][state.Y]==0&&state.X>0)lPos.X=2,state.X=0;
					}
				} else if(input==75) {
					if(lPos.Y>0)--lPos.Y;
					else if(mode==0) {
						if(winside[state.X][1]==0&&state.Y>1)lPos.Y=2,state.Y=1;
						else if(winside[state.X][0]==0&&state.Y>0)lPos.Y=2,state.Y=0;
					}
				} else if(input==77) {
					if(lPos.Y<2)++lPos.Y;
					else if(mode==0) {
						if(winside[state.X][1]==0&&state.Y<1)lPos.Y=0,state.Y=1;
						else if(winside[state.X][2]==0&&state.Y<2)lPos.Y=0,state.Y=2;
					}
				} else if(input==80) {
					if(lPos.X<2)++lPos.X;
					else if(mode==0) {
						if(winside[1][state.Y]==0&&state.X<1)lPos.X=0,state.X=1;
						else if(winside[2][state.Y]==0&&state.X<2)lPos.X=0,state.X=2;
					}
				}
				cout<<"\b\b"<<sym[board[oldState.X][oldState.Y][oldPos.X][oldPos.Y]];
			}
		}
		return -1;
	}
	void printGrid(COORD pos,short state_x,short state_y,Color c=WHITE) {
		cout<<c;
		string border[3][3]= {{"","",""},{"","",""},{"","",""}};
		for(register short i=0; i<3; ++i) {
			setPos(pos);
			cout<<border[i][0]<<""<<border[i][1]<<""<<border[i][1]<<""<<border[i][2];
			++pos.Y;
			setPos(pos);
			cout<<"";
			for(short j=0; j<3; j++) {
				short n=block_color[state_x][state_y][i][j];
				cout<<(n==1?GREEN:(n==2?RED:WHITE))<<sym[board[state_x][state_y][i][j]]<<WHITE<<"";
			}
			++pos.Y;
		}
		setPos(pos);
		cout<<"ةة";
	}
	void printMap() {
		for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)printGrid(nToPos({i,j}),i,j);
		cout<<endl;
	}
	//
	void MoveStone(int side) {
		board[state.X][state.Y][lPos.X][lPos.Y]=side;
		setPos(lToCPos());
		cout<<sym[side];
	}
	int check(int arr[3][3],int side,COORD pos) {
		int x=pos.X,y=pos.Y;
		//
		if(arr[0][y]==side&&arr[1][y]==side&&arr[2][y]==side)return 1;
		//
		if(arr[x][0]==side&&arr[x][1]==side&&arr[x][2]==side)return 2;
		//
		if(arr[0][0]==side&&arr[1][1]==side&&arr[2][2]==side)return 3;
		//
		if(arr[0][2]==side&&arr[1][1]==side&&arr[2][0]==side)return 4;
		return 0;
	}
	void save() {
		ofstream fout("gameData.txt");
		fout<<lPos.X<<" "<<lPos.Y<<" "<<state.X<<" "<<state.Y<<" "<<limit<<" "<<side<<endl;
		for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)for(short k=0; k<3; k++)for(short l=0; l<3; l++)fout<<board[i][j][k][l]<<" ";
		fout<<endl;
		for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)for(short k=0; k<3; k++)for(short l=0; l<3; l++)fout<<block_color[i][j][k][l]<<" ";
		fout<<endl;
		for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)fout<<winside[i][j]<<" ";
		fout<<endl;
		for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)fout<<stateNum[i][j]<<" ";
	}
public:
	void init() {
		int input;
START:
		cls;
		cout<<"[0] ȡ浵\t[1]Ϸ"<<endl<<endl;
		input=getnum;
		if(input==0) {
			ifstream fin("gameData.txt");
			if(!fin.good()) {
				cout<<"Ҳ浵"<<endl;
				pause;
				goto START;
			} else {
				fin>>lPos.X>>lPos.Y>>state.X>>state.Y>>limit>>side;
				for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)for(short k=0; k<3; k++)for(short l=0; l<3; l++)fin>>board[i][j][k][l];
				for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)for(short k=0; k<3; k++)for(short l=0; l<3; l++)fin>>block_color[i][j][k][l];
				for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)fin>>winside[i][j];
				for(short i=0; i<3; ++i)for(short j=0; j<3; ++j)fin>>stateNum[i][j];
				fin.close();
			}
		} else if(input==1) {
			lPos= {1,1};
			state= {1,1};
			limit=0;
			side=1;
			memset(winside,0,sizeof(winside));
			memset(board,0,sizeof(board));
			memset(block_color,0,sizeof(block_color));
			memset(stateNum,0,sizeof(stateNum));
		}
		else goto START;
	}
	void start() {
		int n=0;
		printMap();
		setPos(0,25);
		cout<<"[s] \t[q]˳";
		while(1) {
			setPos(0,23);
			cout<<"Player:"<<side<<"\t "<<(limit==1?"ֻڵǰ":"");

			n=getInput(limit,(side==1?BGREEN:BRED));
			if(n==-1)MessageBox(NULL,"Game error!","Message",MB_OK);
			else if(n==1) {
				save();
				setPos(32,25);
				cout<<"ѱ棡";
			} else if(n==2) {
				return;
			} else if(n==0) {
				setPos(32,25);
				cout<<"        ";
				if(++stateNum[state.X][state.Y]==9)winside[state.X][state.Y]=3;//ˣ
				MoveStone(side);
				n=check(board[state.X][state.Y],side,lPos);
				if(n) {
					winside[state.X][state.Y]=side;
					int x,y;
					COORD pos;
					if(n==1)x=1,y=0,pos= {0,lPos.Y};
					else if(n==2)x=0,y=1,pos= {lPos.X,0};
					else if(n==3)x=1,y=1,pos= {0,0};
					else if(n==4)x=1,y=-1,pos= {0,2};
					cout<<(side==1?GREEN:RED);
					for(short i=0; i<3; ++i) {
						block_color[state.X][state.Y][pos.X][pos.Y]=side;
						setPos(lToCPos(pos));
						cout<<sym[side];
						pos.X+=x,pos.Y+=y;
					}
					cout<<WHITE;
					n=check(winside,side,state);
					if(n) {
						setPos(0,23);
						cout<<"                                    \r"
						    <<"Game Over!\tPlayer "<<side<<" win!"<<endl;
						pause;
						return;
					}
				}
				side=3-side;//
				state=lPos;
				if(winside[state.X][state.Y]) {//һ鲻
					limit=0;
					state= {-1,-1};
					bool end=false;
					//ֱҵе
					for(short i=0; i<3&&end==false; ++i)for(short j=0; j<3&&end==false; ++j)if(winside[i][j]==0)state= {i,j},end=true;
					if(state.X==-1) { //ûпе飬Ϸ
						setPos(0,23);
						cout<<"Ϸƽ֣                                "<<endl;
						pause;
						return;
					}
				} else limit=1;
				lPos= {1,1};
			}
		}
	}
};
int main() {
	hideConsoleCursor();
	setWindowSize(47,30);
	SetConsoleTitle("");
	Game game;
	game.init();
	game.start();
	return 0;
}
