//༭ڣ2019/12/15 14:23
#ifndef CONSOLE_H
#define CONSOLE_H

#include<windows.h>
#include<iostream>
#include<conio.h>

//system
#define pause std::cout<<"밴. . .\n";getch()
//
#define cls system("cls")
//建
#define fflush while(kbhit())getch()
//һ0-9
#define getnum getch()-48

//ĳЩWindows.hҪ
HANDLE console_handle=GetStdHandle(STD_OUTPUT_HANDLE);

/*
setPos
ÿ̨λ
ע⣺xyֵc++෴
÷
setPos(1,3)
λãϽΪ(0,0)

***
***
***
*+*
***

COORDWindows.hнṹ壬x,yڼ¼
÷
1.
COORD pos={1,3}
setPos(pos);
----------------
2.
setPos(1,3);
*/
void setPos(COORD);
void setPos(short,short);

/*
getPos
ÿ̨λ
÷
1.
COORD pos=getPos();
cout<<pos.X<<" "<<pos.Y<<endl;
---------------------------------
2.
cout<<getPos().X<<endl;
*/
COORD getPos();

/*
movePos
ԭĻϷֱƫx,yλ
÷
movePos(1,2);
*/
void movePos(SHORT,SHORT);

/*
toBeginning
صĳеͷ޲صͷ
÷
toBeginning(1);//صһͷ
toBeginning();//صͷ
*/
void toBeginning(SHORT);
void toBeginning();

/*
hideConsoleCursorshowConsoleCursor
ֱΪءʾ̨
*/
void hideConsoleCursor();
void showConsoleCursor();

/*
putValue
ָһ

T t:ָı
short int x,y:
bool retn:Ƿ񷵻ԭλã1أ0أĬΪ0
*/
template<typename T>
void putValue(T,short int,short int,bool);

/*
setWindowSize
ÿ̨ڵĴСͻС
СΪ0ΪͬڴС
ע⣺ССڴڴС
*/
void setWindowSize(short int,short int,short int,short int);

/*
setWindowIcon
ÿ̨ڵͼ
÷
setWindowIcon("icon.ico");
*/
void setWindowIcon(LPCSTR);


/*
⣺
getch()
ʱַASCII루ʾַҲðس

kbhit()
ʱtrue

SetConsoleTitle(char)
ÿ̨
*/


void setPos(COORD pos) {
	SetConsoleCursorPosition(console_handle,pos);
}
void setPos(short x,short y) {
	SetConsoleCursorPosition(console_handle, {x,y});
}
COORD getPos() {
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(console_handle,&csbi);
	return csbi.dwCursorPosition;
}
void movePos(SHORT x,SHORT y) {
	COORD pos=getPos();
	pos.X+=x,pos.Y+=y;
	setPos(pos);
}
void toBeginning(SHORT line) {
	SetConsoleCursorPosition(console_handle, {0,SHORT(line)});
}
void toBeginning() {
	SetConsoleCursorPosition(console_handle, {0,getPos().Y});
}
template<typename T>
void putValue(T t,short int x,short int y,bool retn=false) {
	COORD pos=getPos();
	setPos(x,y);
	std::cout<<t;
	if(retn)setPos(pos);
}
void hideConsoleCursor() {
	CONSOLE_CURSOR_INFO CursorInfo;
	GetConsoleCursorInfo(console_handle, &CursorInfo);//ȡ̨Ϣ
	CursorInfo.bVisible = false; //ؿ̨
	SetConsoleCursorInfo(console_handle, &CursorInfo);//ÿ̨״̬
}
void showConsoleCursor() {
	CONSOLE_CURSOR_INFO CursorInfo;
	GetConsoleCursorInfo(console_handle, &CursorInfo);//ȡ̨Ϣ
	CursorInfo.bVisible = true; //ʾ̨
	SetConsoleCursorInfo(console_handle, &CursorInfo);//ÿ̨״̬
}
void setWindowSize(short int width,short int height,
                   short int buffer_width=0,short int buffer_height=0) {
	if(buffer_width==0)buffer_width=width;
	if(buffer_height==0)buffer_height=height;
	width-=1,height-=1;
	SMALL_RECT rc = {0,0,width,height};
	SetConsoleWindowInfo(console_handle, TRUE, &rc);
	SetConsoleScreenBufferSize(console_handle, {buffer_width,buffer_height});
}
void setWindowIcon(LPCSTR iconPath) {
	HICON cwnd = (HICON)LoadImage(NULL, iconPath, IMAGE_ICON, 0, 0, LR_LOADFROMFILE);
	HWND  hwnd = GetConsoleWindow();
	SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM)cwnd);
}
#endif //CONSOLE_H
